/* A Bison parser, made from cexp.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse cexpparse
#define yylex cexplex
#define yyerror cexperror
#define yylval cexplval
#define yychar cexpchar
#define yydebug cexpdebug
#define yynerrs cexpnerrs
# define	NUMBER	257
# define	STR_CONST	258
# define	FUNC	259
# define	VAR	260
# define	UVAR	261
# define	IDENT	262
# define	KW_CHAR	263
# define	KW_SHORT	264
# define	KW_LONG	265
# define	KW_DOUBLE	266
# define	MODOP	267
# define	NONE	268
# define	OR	269
# define	AND	270
# define	EQ	271
# define	NE	272
# define	LE	273
# define	GE	274
# define	SHL	275
# define	SHR	276
# define	CAST	277
# define	VARCAST	278
# define	DEREF	279
# define	ADDR	280
# define	PREFIX	281
# define	MM	282
# define	PP	283
# define	NEG	284
# define	CALL	285

#line 1 "cexp.y"

/* $Id: cexp.y,v 1.39 2003/04/04 23:56:53 till Exp $ */
/* Grammar definition and lexical analyzer for Cexp */
/* Author: Till Straumann <strauman@slac.stanford.edu>, 2/2002 */

/*
 * Copyright 2002, Stanford University and
 * 		Till Straumann <strauman@slac.stanford.edu>
 * 
 * Stanford Notice
 * ***************
 * 
 * Acknowledgement of sponsorship
 * * * * * * * * * * * * * * * * *
 * This software was produced by the Stanford Linear Accelerator Center,
 * Stanford University, under Contract DE-AC03-76SFO0515 with the Department
 * of Energy.
 * 
 * Government disclaimer of liability
 * - - - - - - - - - - - - - - - - -
 * Neither the United States nor the United States Department of Energy,
 * nor any of their employees, makes any warranty, express or implied,
 * or assumes any legal liability or responsibility for the accuracy,
 * completeness, or usefulness of any data, apparatus, product, or process
 * disclosed, or represents that its use would not infringe privately
 * owned rights.
 * 
 * Stanford disclaimer of liability
 * - - - - - - - - - - - - - - - - -
 * Stanford University makes no representations or warranties, express or
 * implied, nor assumes any liability for the use of this software.
 * 
 * This product is subject to the EPICS open license
 * - - - - - - - - - - - - - - - - - - - - - - - - - 
 * Consult the LICENSE file or http://www.aps.anl.gov/epics/license/open.php
 * for more information.
 * 
 * Maintenance of notice
 * - - - - - - - - - - -
 * In the interest of clarity regarding the origin and status of this
 * software, Stanford University requests that any recipient of it maintain
 * this notice affixed to any distribution by the recipient that contains a
 * copy or derivative of this software.
 */

#include <stdio.h>
#include <fcntl.h>
#include <assert.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#define _INSIDE_CEXP_Y
#include "cexpsyms.h"
#include "cexpmod.h"
#undef  _INSIDE_CEXP_Y
#include "vars.h"

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

/* not letting them live makes not much sense */
#ifndef CONFIG_STRINGS_LIVE_FOREVER
#define CONFIG_STRINGS_LIVE_FOREVER
#endif

#define YYPARSE_PARAM	parm
#define YYLEX_PARAM		parm
#define YYERROR_VERBOSE

#define EVAL_INH	 (((CexpParserCtx)YYPARSE_PARAM)->evalInhibit)
#define PSHEVAL(inh) do { EVAL_INH<<=1; if (inh) EVAL_INH++; } while(0)
#define POPEVAL      do { EVAL_INH>>=1; } while(0)
#define EVAL(stuff)  if (! EVAL_INH ) do { stuff; } while (0)

#define CHECK(cexpTfuncall) do { const char *e=(cexpTfuncall);\
					 if (e) { yyerror(e); YYERROR; } } while (0)

/* acceptable characters for identifiers - must not
 * overlap with operators
 */
#define ISIDENTCHAR(ch) ('_'==(ch) || '@'==(ch))

#define LEXERR	-1
/* ugly hack; helper for word completion */
#define LEXERR_INCOMPLETE_STRING	-100

void yyerror();
int  yylex();

typedef char *LString;

typedef struct CexpParserCtxRec_ {
	const char		*chpt;
	LString			lineStrTbl[10];	/* allow for 10 strings on one line of input */
	CexpTypedValRec	rval;
	unsigned long	evalInhibit;
	FILE			*f;				/* where to print evaluated value			*/
} CexpParserCtxRec;

static CexpSym
varCreate(char *name, CexpType type)
{
CexpSym rval;
	if (!(rval=cexpVarLookup(name,1)/*allow creation*/)) {
		yyerror("unable to add new user variable");
		return 0;
	}
	rval->value.type = type;
	if (CEXP_TYPE_PTRQ(type))
		rval->value.ptv->p=0;
	else switch(type) {
		case TUChar:	rval->value.ptv->c=0;		break;
		case TUShort:	rval->value.ptv->s=0;		break;
		case TULong:	rval->value.ptv->l=0;		break;
		case TFloat:	rval->value.ptv->f=0.0;	break;
		case TDouble:	rval->value.ptv->d=0.0;	break;
		default:
			assert(!"unknown type");
	}
	return rval;
}


#line 127 "cexp.y"
#ifndef YYSTYPE
typedef union {
	CexpTypedValRec				val;
	CexpTypedAddrRec			lval;
	CexpTypedAddr				varp;
	CexpSym						sym;	/* a symbol table entry */
	CexpType					typ;
	CexpBinOp					binop;
	char						*lstr;	/* string in the line string table */
	struct			{
		CexpTypedAddrRec	lval;
		CexpBinOp			op;
	}							fixexp;
	struct			{
		CexpSym				sym;
		char				*mname;		/* string kept in the line string table */
	}							method;
	unsigned long				ul;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		205
#define	YYFLAG		-32768
#define	YYNTBASE	52

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 285 ? yytranslate[x] : 78)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      51,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    46,     2,     2,     2,    36,    23,     2,
      49,    50,    34,    33,    15,    32,    48,    35,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    17,     2,
      26,    18,    27,    16,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    22,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    21,     2,    45,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    19,
      20,    24,    25,    28,    29,    30,    31,    37,    38,    39,
      40,    41,    42,    43,    44,    47
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     2,     5,     9,    17,    20,    24,    32,    34,
      37,    39,    43,    45,    48,    51,    54,    57,    59,    63,
      67,    71,    73,    76,    79,    83,    87,    91,    95,    99,
     103,   107,   111,   115,   119,   123,   127,   131,   135,   139,
     143,   146,   149,   152,   155,   158,   161,   163,   165,   167,
     169,   172,   175,   178,   181,   184,   186,   188,   192,   194,
     196,   198,   200,   203,   205,   208,   210,   212,   214,   216,
     220,   225,   227,   236,   238,   241,   243,   245,   247,   250,
     253,   256,   260,   264,   268,   272,   274,   278,   283,   290,
     294,   299,   306,   315,   326,   339,   354,   371,   390,   411,
     434,   459,   486
};
static const short yyrhs[] =
{
      57,     0,    69,    66,     0,    69,    34,    66,     0,    72,
      49,    34,    66,    50,    49,    50,     0,    69,     8,     0,
      69,    34,     8,     0,    72,    49,    34,     8,    50,    49,
      50,     0,    54,     0,    53,    46,     0,    58,     0,    56,
      15,    58,     0,    51,     0,     8,    51,     0,    55,    51,
       0,    53,    51,     0,    56,    51,     0,    59,     0,    68,
      18,    58,     0,    68,    13,    58,     0,     8,    18,    58,
       0,    75,     0,    60,    59,     0,    61,    59,     0,    59,
      21,    59,     0,    59,    22,    59,     0,    59,    23,    59,
       0,    59,    25,    59,     0,    59,    24,    59,     0,    59,
      27,    59,     0,    59,    26,    59,     0,    59,    28,    59,
       0,    59,    29,    59,     0,    59,    30,    59,     0,    59,
      31,    59,     0,    59,    33,    59,     0,    59,    32,    59,
       0,    59,    34,    59,     0,    59,    35,    59,     0,    59,
      36,    59,     0,    59,    19,     0,    59,    20,     0,    42,
      68,     0,    43,    68,     0,    68,    42,     0,    68,    43,
       0,    68,     0,     3,     0,     4,     0,    77,     0,    46,
      75,     0,    45,    75,     0,    32,    75,     0,    23,     6,
       0,    23,     7,     0,     6,     0,     7,     0,    49,    68,
      50,     0,     6,     0,     7,     0,     5,     0,    65,     0,
      70,    67,     0,    67,     0,    34,    75,     0,     9,     0,
      10,     0,    11,     0,    12,     0,    49,    69,    50,     0,
      49,    69,    34,    50,     0,    69,     0,    49,    72,    49,
      34,    50,    49,    50,    50,     0,     5,     0,    23,     5,
       0,    63,     0,    62,     0,    64,     0,    70,    75,     0,
      71,    75,     0,    73,    75,     0,     6,    48,     8,     0,
       7,    48,     8,     0,     5,    48,     8,     0,    49,    56,
      50,     0,    74,     0,    76,    49,    50,     0,    76,    49,
      58,    50,     0,    76,    49,    58,    15,    58,    50,     0,
      77,    49,    50,     0,    77,    49,    58,    50,     0,    77,
      49,    58,    15,    58,    50,     0,    77,    49,    58,    15,
      58,    15,    58,    50,     0,    77,    49,    58,    15,    58,
      15,    58,    15,    58,    50,     0,    77,    49,    58,    15,
      58,    15,    58,    15,    58,    15,    58,    50,     0,    77,
      49,    58,    15,    58,    15,    58,    15,    58,    15,    58,
      15,    58,    50,     0,    77,    49,    58,    15,    58,    15,
      58,    15,    58,    15,    58,    15,    58,    15,    58,    50,
       0,    77,    49,    58,    15,    58,    15,    58,    15,    58,
      15,    58,    15,    58,    15,    58,    15,    58,    50,     0,
      77,    49,    58,    15,    58,    15,    58,    15,    58,    15,
      58,    15,    58,    15,    58,    15,    58,    15,    58,    50,
       0,    77,    49,    58,    15,    58,    15,    58,    15,    58,
      15,    58,    15,    58,    15,    58,    15,    58,    15,    58,
      15,    58,    50,     0,    77,    49,    58,    15,    58,    15,
      58,    15,    58,    15,    58,    15,    58,    15,    58,    15,
      58,    15,    58,    15,    58,    15,    58,    50,     0,    77,
      49,    58,    15,    58,    15,    58,    15,    58,    15,    58,
      15,    58,    15,    58,    15,    58,    15,    58,    15,    58,
      15,    58,    15,    58,    50,     0,    77,    49,    58,    15,
      58,    15,    58,    15,    58,    15,    58,    15,    58,    15,
      58,    15,    58,    15,    58,    15,    58,    15,    58,    15,
      58,    15,    58,    50,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   204,   207,   209,   211,   215,   220,   225,   232,   232,
     235,   236,   240,   242,   248,   249,   253,   290,   291,   293,
     300,   309,   310,   314,   318,   320,   322,   324,   326,   328,
     330,   332,   334,   336,   338,   340,   342,   344,   346,   348,
     352,   356,   360,   362,   367,   369,   371,   375,   380,   384,
     385,   387,   389,   395,   397,   401,   403,   405,   409,   411,
     413,   417,   418,   436,   437,   452,   454,   456,   458,   462,
     466,   471,   488,   493,   495,   497,   509,   523,   524,   526,
     528,   532,   534,   536,   542,   544,   545,   547,   549,   551,
     553,   555,   557,   559,   561,   563,   565,   567,   569,   571,
     573,   575,   577
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "NUMBER", "STR_CONST", "FUNC", "VAR", "UVAR", 
  "IDENT", "KW_CHAR", "KW_SHORT", "KW_LONG", "KW_DOUBLE", "MODOP", "NONE", 
  "','", "'?'", "':'", "'='", "OR", "AND", "'|'", "'^'", "'&'", "EQ", 
  "NE", "'<'", "'>'", "LE", "GE", "SHL", "SHR", "'-'", "'+'", "'*'", 
  "'/'", "'%'", "CAST", "VARCAST", "DEREF", "ADDR", "PREFIX", "MM", "PP", 
  "NEG", "'~'", "'!'", "CALL", "'.'", "'('", "')'", "'\\n'", "input", 
  "redef", "newdef", "def", "commaexp", "line", "exp", "binexp", "or", 
  "and", "prefix", "postfix", "unexp", "lvar", "anyvar", "clvar", "lval", 
  "typeid", "cast", "pcast", "fptype", "fpcast", "funcp", "castexp", 
  "symmethod", "call", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    52,    53,    53,    53,    54,    54,    54,    55,    55,
      56,    56,    57,    57,    57,    57,    57,    58,    58,    58,
      58,    59,    59,    59,    59,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    59,    59,    59,    59,    59,    59,
      60,    61,    62,    62,    63,    63,    63,    64,    64,    64,
      64,    64,    64,    64,    64,    65,    65,    65,    66,    66,
      66,    67,    67,    68,    68,    69,    69,    69,    69,    70,
      71,    72,    73,    74,    74,    74,    74,    75,    75,    75,
      75,    76,    76,    76,    77,    77,    77,    77,    77,    77,
      77,    77,    77,    77,    77,    77,    77,    77,    77,    77,
      77,    77,    77
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     1,     2,     3,     7,     2,     3,     7,     1,     2,
       1,     3,     1,     2,     2,     2,     2,     1,     3,     3,
       3,     1,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     2,     2,     2,     2,     2,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     1,     1,     3,     1,     1,
       1,     1,     2,     1,     2,     1,     1,     1,     1,     3,
       4,     1,     8,     1,     2,     1,     1,     1,     2,     2,
       2,     3,     3,     3,     3,     1,     3,     4,     6,     3,
       4,     6,     8,    10,    12,    14,    16,    18,    20,    22,
      24,    26,    28
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       0,    47,    48,    73,    55,    56,     0,    65,    66,    67,
      68,     0,     0,     0,     0,     0,     0,     0,     0,    12,
       0,     8,     0,     0,     1,    10,    17,     0,     0,    76,
      75,    77,    61,    63,    46,    71,     0,     0,     0,     0,
      85,    21,     0,    49,     0,     0,     0,     0,    13,    74,
      53,    54,    46,    52,    64,    55,    56,     0,    42,     0,
      43,    51,    50,     0,     0,    46,    71,     0,     9,    15,
      14,     0,    16,    40,    41,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    22,    23,     0,     0,    44,    45,    60,    58,    59,
       5,     0,     2,    62,    78,    79,     0,    80,     0,     0,
      83,    81,    82,    20,     0,     0,    62,    84,    57,     0,
      69,     0,    11,    24,    25,    26,    28,    27,    30,    29,
      31,    32,    33,    34,    36,    35,    37,    38,    39,    19,
      18,     6,     3,     0,    86,     0,    89,     0,    70,     0,
       0,     0,     0,    87,     0,    90,     0,     0,     0,     0,
       0,     0,     0,     0,    88,     0,    91,     0,     7,     4,
       0,    72,     0,    92,     0,     0,    93,     0,     0,    94,
       0,     0,    95,     0,     0,    96,     0,     0,    97,     0,
       0,    98,     0,     0,    99,     0,     0,   100,     0,     0,
     101,     0,   102,     0,     0,     0
};

static const short yydefgoto[] =
{
     203,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,   102,    33,    52,    35,    36,    37,
      38,    39,    40,    41,    42,    43
};

static const short yypact[] =
{
      94,-32768,-32768,   -18,   -15,   -11,   -12,-32768,-32768,-32768,
  -32768,    83,     6,     6,    16,    16,     6,     6,   259,-32768,
      64,-32768,   -43,   -10,-32768,-32768,   311,     6,     6,-32768,
  -32768,-32768,-32768,-32768,   189,   215,     6,     6,     9,     6,
  -32768,-32768,    15,    62,    26,    28,    58,   280,-32768,-32768,
  -32768,-32768,   -22,-32768,-32768,-32768,-32768,   112,-32768,    10,
  -32768,-32768,-32768,   116,    11,   161,    99,   108,-32768,-32768,
  -32768,   280,-32768,-32768,-32768,     6,     6,     6,     6,     6,
       6,     6,     6,     6,     6,     6,     6,     6,     6,     6,
       6,   328,   344,   280,   280,-32768,-32768,-32768,-32768,-32768,
  -32768,   273,-32768,-32768,-32768,-32768,    96,-32768,   163,   211,
  -32768,-32768,-32768,-32768,   110,   113,-32768,-32768,-32768,   123,
  -32768,   124,-32768,   359,   373,   386,   397,   397,   194,   194,
     194,   194,   203,   203,   206,   206,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,   310,-32768,    12,-32768,    13,-32768,   126,
     127,   130,   280,-32768,   280,-32768,   133,   134,   136,   138,
      17,   139,   141,   142,-32768,   280,-32768,   144,-32768,-32768,
      20,-32768,   280,-32768,    41,   280,-32768,    45,   280,-32768,
      77,   280,-32768,    81,   280,-32768,    92,   280,-32768,    98,
     280,-32768,   101,   280,-32768,   105,   280,-32768,   114,   280,
  -32768,   148,-32768,   162,   200,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,-32768,-32768,   183,-32768,   -40,    -3,-32768,-32768,
  -32768,-32768,-32768,-32768,   -98,   -17,     0,   -14,   -13,-32768,
     192,-32768,-32768,   260,-32768,-32768
};


#define	YYLAST		433


static const short yytable[] =
{
      34,    59,    59,   142,    66,    71,    47,   113,    70,     1,
       2,     3,     4,     5,    58,    60,    55,    56,    65,   103,
      95,    96,    55,    56,    91,    92,    71,   152,   154,    11,
      44,   122,   165,    45,   110,   172,   111,    46,    12,    48,
      13,    72,   116,   115,    59,   151,    59,    34,    14,    15,
      13,    16,    17,   139,   140,    18,   175,   114,   106,    57,
     178,   117,   153,   155,   108,    57,   112,   166,   145,   147,
     173,    34,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    49,    50,
      51,   176,   181,    34,    34,   179,   184,     1,     2,     3,
       4,     5,     6,     7,     8,     9,    10,   187,    34,    34,
      68,   109,   159,   190,   160,    69,   193,    11,    55,    56,
     196,     7,     8,     9,    10,   170,    12,   182,    13,   199,
     143,   185,   174,   119,    47,   177,    14,    15,   180,    16,
      17,   183,   188,    18,   186,    19,    13,   189,   191,   120,
     192,   194,    34,   195,    34,   197,   198,   121,   149,   201,
     118,    57,   204,   120,   200,    34,     1,     2,     3,     4,
       5,    63,    34,   148,    93,    34,   156,   157,    34,    94,
     158,    34,   161,   162,    34,   163,    11,    34,   164,   167,
      34,   168,   169,    34,   171,    12,    34,    13,   202,    34,
     205,    64,    93,    95,    96,    14,    15,    94,    16,    17,
      67,   118,    18,   144,     1,     2,     3,     4,     5,    63,
      97,    98,    99,   100,    84,    85,    86,    87,    88,    89,
      90,    95,    96,     0,    11,    86,    87,    88,    89,    90,
      88,    89,    90,    12,     0,    13,     0,     0,     0,   101,
       0,     0,     0,    14,    15,     0,    16,    17,     0,     0,
      18,   146,     1,     2,     3,     4,     5,    63,     7,     8,
       9,    10,    53,    54,     0,     0,    61,    62,    97,    98,
      99,   141,    11,     1,     2,     3,     4,     5,    63,     0,
       0,    12,     0,    13,     0,     0,   104,   105,     0,   107,
       0,    14,    15,    11,    16,    17,     0,     0,    18,     0,
       0,     0,    12,     0,    13,    97,    98,    99,   150,     0,
       0,     0,    14,    15,     0,    16,    17,     0,     0,    18,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90
};

static const short yycheck[] =
{
       0,    14,    15,   101,    18,    15,    18,    47,    51,     3,
       4,     5,     6,     7,    14,    15,     6,     7,    18,    36,
      42,    43,     6,     7,    27,    28,    15,    15,    15,    23,
      48,    71,    15,    48,     8,    15,     8,    48,    32,    51,
      34,    51,    59,    57,    57,   143,    59,    47,    42,    43,
      34,    45,    46,    93,    94,    49,    15,    57,    49,    49,
      15,    50,    50,    50,    49,    49,     8,    50,   108,   109,
      50,    71,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,     5,     6,
       7,    50,    15,    93,    94,    50,    15,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    15,   108,   109,
      46,    49,   152,    15,   154,    51,    15,    23,     6,     7,
      15,     9,    10,    11,    12,   165,    32,    50,    34,    15,
      34,    50,   172,    34,    18,   175,    42,    43,   178,    45,
      46,   181,    50,    49,   184,    51,    34,   187,    50,    50,
     190,    50,   152,   193,   154,    50,   196,    49,    34,   199,
      50,    49,     0,    50,    50,   165,     3,     4,     5,     6,
       7,     8,   172,    50,    13,   175,    50,    50,   178,    18,
      50,   181,    49,    49,   184,    49,    23,   187,    50,    50,
     190,    50,    50,   193,    50,    32,   196,    34,    50,   199,
       0,    18,    13,    42,    43,    42,    43,    18,    45,    46,
      18,    50,    49,    50,     3,     4,     5,     6,     7,     8,
       5,     6,     7,     8,    30,    31,    32,    33,    34,    35,
      36,    42,    43,    -1,    23,    32,    33,    34,    35,    36,
      34,    35,    36,    32,    -1,    34,    -1,    -1,    -1,    34,
      -1,    -1,    -1,    42,    43,    -1,    45,    46,    -1,    -1,
      49,    50,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    12,    13,    -1,    -1,    16,    17,     5,     6,
       7,     8,    23,     3,     4,     5,     6,     7,     8,    -1,
      -1,    32,    -1,    34,    -1,    -1,    36,    37,    -1,    39,
      -1,    42,    43,    23,    45,    46,    -1,    -1,    49,    -1,
      -1,    -1,    32,    -1,    34,     5,     6,     7,     8,    -1,
      -1,    -1,    42,    43,    -1,    45,    46,    -1,    -1,    49,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36
};
#define YYPURE 1

/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 1:
#line 204 "cexp.y"
{ CexpParserCtx pa=parm; pa->rval=yyvsp[0].val; YYACCEPT; ;
    break;}
case 2:
#line 208 "cexp.y"
{ EVAL(yyvsp[0].varp->type = yyvsp[-1].typ;); CHECK(cexpTA2TV(&yyval.val,yyvsp[0].varp)); ;
    break;}
case 3:
#line 210 "cexp.y"
{ EVAL(yyvsp[0].varp->type = CEXP_TYPE_BASE2PTR(yyvsp[-2].typ);); CHECK(cexpTA2TV(&yyval.val,yyvsp[0].varp)); ;
    break;}
case 4:
#line 212 "cexp.y"
{ EVAL(yyvsp[-3].varp->type = yyvsp[-6].typ); CHECK(cexpTA2TV(&yyval.val,yyvsp[-3].varp)); ;
    break;}
case 5:
#line 216 "cexp.y"
{ CexpSym found;
					  EVAL(if (!(found = varCreate(yyvsp[0].lstr, yyvsp[-1].typ))) YYERROR;);
					  CHECK(cexpTA2TV(&yyval.val,&found->value));
					;
    break;}
case 6:
#line 221 "cexp.y"
{ CexpSym found;
					  EVAL(if (!(found = varCreate(yyvsp[0].lstr, CEXP_TYPE_BASE2PTR(yyvsp[-2].typ)))) YYERROR;);
					  CHECK(cexpTA2TV(&yyval.val,&found->value));
					;
    break;}
case 7:
#line 226 "cexp.y"
{ CexpSym found;
					  EVAL(if (!(found = varCreate(yyvsp[-3].lstr, yyvsp[-6].typ))) YYERROR;);
					  CHECK(cexpTA2TV(&yyval.val,&found->value));
					;
    break;}
case 11:
#line 237 "cexp.y"
{ yyval.val=yyvsp[0].val; ;
    break;}
case 12:
#line 241 "cexp.y"
{	yyval.val.type=TVoid; ;
    break;}
case 13:
#line 243 "cexp.y"
{
						yyval.val.type=TVoid;
						yyerror("unknown symbol/variable; '=' expected");
						YYERROR;
					;
    break;}
case 15:
#line 249 "cexp.y"
{
						fprintf(stderr,"Symbol already defined; append '!' to enforce recast\n");
						YYERROR;
					;
    break;}
case 16:
#line 254 "cexp.y"
{FILE *f=((CexpParserCtx)parm)->f;
						yyval.val=yyvsp[-1].val;
						if (CEXP_TYPE_FPQ(yyvsp[-1].val.type)) {
							CHECK(cexpTypeCast(&yyvsp[-1].val,TDouble,0));
							if (f)
								fprintf(f,"%f\n",yyvsp[-1].val.tv.d);
						}else {
							if (TUChar==yyvsp[-1].val.type) {
								unsigned char c=yyvsp[-1].val.tv.c,e=0;
								if (f) {
									fprintf(f,"0x%02x (%d)",c,c);
									switch (c) {
										case 0:	    e=1; c='0'; break;
										case '\t':	e=1; c='t'; break;
										case '\r':	e=1; c='r'; break;
										case '\n':	e=1; c='n'; break;
										case '\f':	e=1; c='f'; break;
										default: 	break;
									}
									if (isprint(c)) {
										fputc('\'',f);
										if (e) fputc('\\',f);
										fputc(c,f);
										fputc('\'',f);
									}
									fputc('\n',f);
								}
							} else {
								CHECK(cexpTypeCast(&yyvsp[-1].val,TULong,0));
								if (f)
									fprintf(f,"0x%08lx (%ld)\n",yyvsp[-1].val.tv.l,yyvsp[-1].val.tv.l);
							}
						}
					;
    break;}
case 18:
#line 292 "cexp.y"
{ yyval.val=yyvsp[0].val; EVAL(CHECK(cexpTVAssign(&yyvsp[-2].lval, &yyvsp[0].val))); ;
    break;}
case 19:
#line 294 "cexp.y"
{ EVAL( \
						CHECK(cexpTA2TV(&yyval.val,&yyvsp[-2].lval)); \
						CHECK(cexpTVBinOp(&yyval.val, &yyval.val, &yyvsp[0].val, yyvsp[-1].binop)); \
						CHECK(cexpTVAssign(&yyvsp[-2].lval,&yyval.val)); \
					  );
					;
    break;}
case 20:
#line 301 "cexp.y"
{ CexpSym found;
					  yyval.val=yyvsp[0].val; EVAL(if (!(found=varCreate(yyvsp[-2].lstr, yyvsp[0].val.type))) {	\
									YYERROR; 								\
								}\
								CHECK(cexpTVAssign(&found->value, &yyvsp[0].val)); );
					;
    break;}
case 22:
#line 311 "cexp.y"
{ yyval.val.tv.l = yyvsp[-1].ul || cexpTVTrueQ(&yyvsp[0].val);
					  yyval.val.type = TULong;
					  POPEVAL; ;
    break;}
case 23:
#line 315 "cexp.y"
{ yyval.val.tv.l = yyvsp[-1].ul && cexpTVTrueQ(&yyvsp[0].val);
					  yyval.val.type = TULong;
					  POPEVAL; ;
    break;}
case 24:
#line 319 "cexp.y"
{ CHECK(cexpTVBinOp(&yyval.val,&yyvsp[-2].val,&yyvsp[0].val,OOr)); ;
    break;}
case 25:
#line 321 "cexp.y"
{ CHECK(cexpTVBinOp(&yyval.val,&yyvsp[-2].val,&yyvsp[0].val,OXor)); ;
    break;}
case 26:
#line 323 "cexp.y"
{ CHECK(cexpTVBinOp(&yyval.val,&yyvsp[-2].val,&yyvsp[0].val,OAnd)); ;
    break;}
case 27:
#line 325 "cexp.y"
{ CHECK(cexpTVBinOp(&yyval.val,&yyvsp[-2].val,&yyvsp[0].val,ONe)); ;
    break;}
case 28:
#line 327 "cexp.y"
{ CHECK(cexpTVBinOp(&yyval.val,&yyvsp[-2].val,&yyvsp[0].val,OEq)); ;
    break;}
case 29:
#line 329 "cexp.y"
{ CHECK(cexpTVBinOp(&yyval.val,&yyvsp[-2].val,&yyvsp[0].val,OGt)); ;
    break;}
case 30:
#line 331 "cexp.y"
{ CHECK(cexpTVBinOp(&yyval.val,&yyvsp[-2].val,&yyvsp[0].val,OLt)); ;
    break;}
case 31:
#line 333 "cexp.y"
{ CHECK(cexpTVBinOp(&yyval.val,&yyvsp[-2].val,&yyvsp[0].val,OLe)); ;
    break;}
case 32:
#line 335 "cexp.y"
{ CHECK(cexpTVBinOp(&yyval.val,&yyvsp[-2].val,&yyvsp[0].val,OGe)); ;
    break;}
case 33:
#line 337 "cexp.y"
{ CHECK(cexpTVBinOp(&yyval.val,&yyvsp[-2].val,&yyvsp[0].val,OShL)); ;
    break;}
case 34:
#line 339 "cexp.y"
{ CHECK(cexpTVBinOp(&yyval.val,&yyvsp[-2].val,&yyvsp[0].val,OShR)); ;
    break;}
case 35:
#line 341 "cexp.y"
{ CHECK(cexpTVBinOp(&yyval.val,&yyvsp[-2].val,&yyvsp[0].val,OAdd)); ;
    break;}
case 36:
#line 343 "cexp.y"
{ CHECK(cexpTVBinOp(&yyval.val,&yyvsp[-2].val,&yyvsp[0].val,OSub)); ;
    break;}
case 37:
#line 345 "cexp.y"
{ CHECK(cexpTVBinOp(&yyval.val,&yyvsp[-2].val,&yyvsp[0].val,OMul)); ;
    break;}
case 38:
#line 347 "cexp.y"
{ CHECK(cexpTVBinOp(&yyval.val,&yyvsp[-2].val,&yyvsp[0].val,ODiv)); ;
    break;}
case 39:
#line 349 "cexp.y"
{ CHECK(cexpTVBinOp(&yyval.val,&yyvsp[-2].val,&yyvsp[0].val,OMod)); ;
    break;}
case 40:
#line 353 "cexp.y"
{ yyval.ul=cexpTVTrueQ(&yyvsp[-1].val); PSHEVAL(yyval.ul); ;
    break;}
case 41:
#line 357 "cexp.y"
{ yyval.ul=cexpTVTrueQ(&yyvsp[-1].val); PSHEVAL( ! yyval.ul); ;
    break;}
case 42:
#line 361 "cexp.y"
{ yyval.fixexp.lval=yyvsp[0].lval; yyval.fixexp.op=OSub; ;
    break;}
case 43:
#line 363 "cexp.y"
{ yyval.fixexp.lval=yyvsp[0].lval; yyval.fixexp.op=OAdd; ;
    break;}
case 44:
#line 368 "cexp.y"
{ yyval.fixexp.lval=yyvsp[-1].lval; yyval.fixexp.op=OSub; ;
    break;}
case 45:
#line 370 "cexp.y"
{ yyval.fixexp.lval=yyvsp[-1].lval; yyval.fixexp.op=OAdd; ;
    break;}
case 46:
#line 372 "cexp.y"
{ yyval.fixexp.lval=yyvsp[0].lval; yyval.fixexp.op=ONoop; ;
    break;}
case 50:
#line 386 "cexp.y"
{ yyval.val.type=TULong; yyval.val.tv.l = ! cexpTVTrueQ(&yyvsp[0].val); ;
    break;}
case 51:
#line 388 "cexp.y"
{ CHECK(cexpTVUnOp(&yyval.val,&yyvsp[0].val,OCpl)); ;
    break;}
case 52:
#line 390 "cexp.y"
{ CHECK(cexpTVUnOp(&yyval.val,&yyvsp[0].val,ONeg)); ;
    break;}
case 53:
#line 396 "cexp.y"
{ CHECK(cexpTVPtr(&yyval.val, &yyvsp[0].sym->value)); ;
    break;}
case 54:
#line 398 "cexp.y"
{ CHECK(cexpTVPtr(&yyval.val, &yyvsp[0].sym->value)); ;
    break;}
case 55:
#line 402 "cexp.y"
{ yyval.lval=yyvsp[0].sym->value; ;
    break;}
case 56:
#line 404 "cexp.y"
{ yyval.lval=yyvsp[0].sym->value; ;
    break;}
case 57:
#line 406 "cexp.y"
{ yyval.lval=yyvsp[-1].lval; ;
    break;}
case 58:
#line 410 "cexp.y"
{ yyval.varp=&yyvsp[0].sym->value; ;
    break;}
case 59:
#line 412 "cexp.y"
{ yyval.varp=&yyvsp[0].sym->value; ;
    break;}
case 60:
#line 414 "cexp.y"
{ yyval.varp=&yyvsp[0].sym->value; ;
    break;}
case 62:
#line 419 "cexp.y"
{ CexpTypedValRec v;
						v.type=yyvsp[0].lval.type; v.tv=*yyvsp[0].lval.ptv;
						CHECK(cexpTypeCast(&v,yyvsp[-1].typ,1));
						yyval.lval=yyvsp[0].lval;
						yyval.lval.type=yyvsp[-1].typ;
					;
    break;}
case 64:
#line 438 "cexp.y"
{ if (!CEXP_TYPE_PTRQ(yyvsp[0].val.type) || CEXP_TYPE_FUNQ(yyvsp[0].val.type)) {
						yyerror("not a valid lval address");
						YYERROR;
					  }
					  yyval.lval.type=CEXP_TYPE_PTR2BASE(yyvsp[0].val.type);
					  yyval.lval.ptv=(CexpVal)yyvsp[0].val.tv.p;
					;
    break;}
case 65:
#line 453 "cexp.y"
{ yyval.typ=TUChar; ;
    break;}
case 66:
#line 455 "cexp.y"
{ yyval.typ=TUShort; ;
    break;}
case 67:
#line 457 "cexp.y"
{ yyval.typ=TULong; ;
    break;}
case 68:
#line 459 "cexp.y"
{ yyval.typ=TDouble; ;
    break;}
case 69:
#line 463 "cexp.y"
{ yyval.typ=yyvsp[-1].typ; ;
    break;}
case 70:
#line 468 "cexp.y"
{ yyval.typ=CEXP_TYPE_BASE2PTR(yyvsp[-2].typ); ;
    break;}
case 71:
#line 472 "cexp.y"
{ switch (yyvsp[0].typ) {
						default:
							yyerror("invalid type for function pointer cast");
						YYERROR;

						case TDouble:
							yyval.typ=TDFuncP;
						break;

						case TULong:
							yyval.typ=TFuncP;
						break;
					  }
					;
    break;}
case 72:
#line 490 "cexp.y"
{ yyval.typ=yyvsp[-6].typ; ;
    break;}
case 73:
#line 494 "cexp.y"
{ yyval.val.type=yyvsp[0].sym->value.type; yyval.val.tv.p=(void*)yyvsp[0].sym->value.ptv; ;
    break;}
case 74:
#line 496 "cexp.y"
{ yyval.val.type=yyvsp[0].sym->value.type; yyval.val.tv.p=(void*)yyvsp[0].sym->value.ptv; ;
    break;}
case 75:
#line 498 "cexp.y"
{ CexpTypedValRec tmp;
					  EVAL( \
						CHECK(cexpTA2TV(&yyval.val,&yyvsp[0].fixexp.lval)); \
						tmp.type=TUChar; \
						tmp.tv.c=1; \
						if (ONoop != yyvsp[0].fixexp.op) { \
							CHECK(cexpTVBinOp(&tmp,&yyval.val,&tmp,yyvsp[0].fixexp.op)); \
							CHECK(cexpTVAssign(&yyvsp[0].fixexp.lval,&tmp)); \
						} \
					  );
					;
    break;}
case 76:
#line 510 "cexp.y"
{ CexpTypedValRec tmp;
					  EVAL( \
						CHECK(cexpTA2TV(&yyval.val,&yyvsp[0].fixexp.lval)); \
						tmp.type=TUChar; \
						tmp.tv.c=1; \
						if (ONoop != yyvsp[0].fixexp.op) { \
							CHECK(cexpTVBinOp(&yyval.val,&yyval.val,&tmp,yyvsp[0].fixexp.op)); \
							CHECK(cexpTVAssign(&yyvsp[0].fixexp.lval,&yyval.val)); \
						} \
					  );
					;
    break;}
case 78:
#line 525 "cexp.y"
{ yyval.val=yyvsp[0].val; CHECK(cexpTypeCast(&yyval.val,yyvsp[-1].typ,CNV_FORCE)); ;
    break;}
case 79:
#line 527 "cexp.y"
{ yyval.val=yyvsp[0].val; CHECK(cexpTypeCast(&yyval.val,yyvsp[-1].typ,CNV_FORCE)); ;
    break;}
case 80:
#line 529 "cexp.y"
{ yyval.val=yyvsp[0].val; CHECK(cexpTypeCast(&yyval.val,yyvsp[-1].typ,CNV_FORCE)); ;
    break;}
case 81:
#line 533 "cexp.y"
{ yyval.method.sym = yyvsp[-2].sym; yyval.method.mname=yyvsp[0].lstr; ;
    break;}
case 82:
#line 535 "cexp.y"
{ yyval.method.sym = yyvsp[-2].sym; yyval.method.mname=yyvsp[0].lstr; ;
    break;}
case 83:
#line 537 "cexp.y"
{ yyval.method.sym = yyvsp[-2].sym; yyval.method.mname=yyvsp[0].lstr; ;
    break;}
case 84:
#line 543 "cexp.y"
{ yyval.val=yyvsp[-1].val; ;
    break;}
case 86:
#line 546 "cexp.y"
{	EVAL(CHECK(cexpSymMember(&yyval.val, yyvsp[-2].method.sym, yyvsp[-2].method.mname, 0))); ;
    break;}
case 87:
#line 548 "cexp.y"
{	EVAL(CHECK(cexpSymMember(&yyval.val, yyvsp[-3].method.sym, yyvsp[-3].method.mname, &yyvsp[-1].val, 0))); ;
    break;}
case 88:
#line 550 "cexp.y"
{	EVAL(CHECK(cexpSymMember(&yyval.val, yyvsp[-5].method.sym, yyvsp[-5].method.mname, &yyvsp[-3].val, &yyvsp[-1].val, 0))); ;
    break;}
case 89:
#line 552 "cexp.y"
{	EVAL(CHECK(cexpTVFnCall(&yyval.val,&yyvsp[-2].val,0))); ;
    break;}
case 90:
#line 554 "cexp.y"
{	EVAL(CHECK(cexpTVFnCall(&yyval.val,&yyvsp[-3].val,&yyvsp[-1].val,0))); ;
    break;}
case 91:
#line 556 "cexp.y"
{	EVAL(CHECK(cexpTVFnCall(&yyval.val,&yyvsp[-5].val,&yyvsp[-3].val,&yyvsp[-1].val,0))); ;
    break;}
case 92:
#line 558 "cexp.y"
{	EVAL(CHECK(cexpTVFnCall(&yyval.val,&yyvsp[-7].val,&yyvsp[-5].val,&yyvsp[-3].val,&yyvsp[-1].val,0))); ;
    break;}
case 93:
#line 560 "cexp.y"
{	EVAL(CHECK(cexpTVFnCall(&yyval.val,&yyvsp[-9].val,&yyvsp[-7].val,&yyvsp[-5].val,&yyvsp[-3].val,&yyvsp[-1].val,0))); ;
    break;}
case 94:
#line 562 "cexp.y"
{	EVAL(CHECK(cexpTVFnCall(&yyval.val,&yyvsp[-11].val,&yyvsp[-9].val,&yyvsp[-7].val,&yyvsp[-5].val,&yyvsp[-3].val,&yyvsp[-1].val,0))); ;
    break;}
case 95:
#line 564 "cexp.y"
{	EVAL(CHECK(cexpTVFnCall(&yyval.val,&yyvsp[-13].val,&yyvsp[-11].val,&yyvsp[-9].val,&yyvsp[-7].val,&yyvsp[-5].val,&yyvsp[-3].val,&yyvsp[-1].val,0))); ;
    break;}
case 96:
#line 566 "cexp.y"
{	EVAL(CHECK(cexpTVFnCall(&yyval.val,&yyvsp[-15].val,&yyvsp[-13].val,&yyvsp[-11].val,&yyvsp[-9].val,&yyvsp[-7].val,&yyvsp[-5].val,&yyvsp[-3].val,&yyvsp[-1].val,0))); ;
    break;}
case 97:
#line 568 "cexp.y"
{	EVAL(CHECK(cexpTVFnCall(&yyval.val,&yyvsp[-17].val,&yyvsp[-15].val,&yyvsp[-13].val,&yyvsp[-11].val,&yyvsp[-9].val,&yyvsp[-7].val,&yyvsp[-5].val,&yyvsp[-3].val,&yyvsp[-1].val,0))); ;
    break;}
case 98:
#line 570 "cexp.y"
{	EVAL(CHECK(cexpTVFnCall(&yyval.val,&yyvsp[-19].val,&yyvsp[-17].val,&yyvsp[-15].val,&yyvsp[-13].val,&yyvsp[-11].val,&yyvsp[-9].val,&yyvsp[-7].val,&yyvsp[-5].val,&yyvsp[-3].val,&yyvsp[-1].val,0))); ;
    break;}
case 99:
#line 572 "cexp.y"
{	EVAL(CHECK(cexpTVFnCall(&yyval.val,&yyvsp[-21].val,&yyvsp[-19].val,&yyvsp[-17].val,&yyvsp[-15].val,&yyvsp[-13].val,&yyvsp[-11].val,&yyvsp[-9].val,&yyvsp[-7].val,&yyvsp[-5].val,&yyvsp[-3].val,&yyvsp[-1].val,0))); ;
    break;}
case 100:
#line 574 "cexp.y"
{	EVAL(CHECK(cexpTVFnCall(&yyval.val,&yyvsp[-23].val,&yyvsp[-21].val,&yyvsp[-19].val,&yyvsp[-17].val,&yyvsp[-15].val,&yyvsp[-13].val,&yyvsp[-11].val,&yyvsp[-9].val,&yyvsp[-7].val,&yyvsp[-5].val,&yyvsp[-3].val,&yyvsp[-1].val,0))); ;
    break;}
case 101:
#line 576 "cexp.y"
{	EVAL(CHECK(cexpTVFnCall(&yyval.val,&yyvsp[-25].val,&yyvsp[-23].val,&yyvsp[-21].val,&yyvsp[-19].val,&yyvsp[-17].val,&yyvsp[-15].val,&yyvsp[-13].val,&yyvsp[-11].val,&yyvsp[-9].val,&yyvsp[-7].val,&yyvsp[-5].val,&yyvsp[-3].val,&yyvsp[-1].val,0))); ;
    break;}
case 102:
#line 578 "cexp.y"
{	EVAL(CHECK(cexpTVFnCall(&yyval.val,&yyvsp[-27].val,&yyvsp[-25].val,&yyvsp[-23].val,&yyvsp[-21].val,&yyvsp[-19].val,&yyvsp[-17].val,&yyvsp[-15].val,&yyvsp[-13].val,&yyvsp[-11].val,&yyvsp[-9].val,&yyvsp[-7].val,&yyvsp[-5].val,&yyvsp[-3].val,&yyvsp[-1].val,0))); ;
    break;}
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 582 "cexp.y"



/* add a string to the line string table returning its index
 * RETURNS a negative number on error
 */
LString
lstAddString(CexpParserCtx env, char *string)
{
LString			rval=0;
LString			*chppt;
int				i;
	for (i=0,chppt=env->lineStrTbl;
		 i<sizeof(env->lineStrTbl)/sizeof(env->lineStrTbl[0]);
		 i++,chppt++) {
		if (*chppt) {
			if  (strcmp(string,*chppt))			continue;
			else /* string exists already */	return *chppt;
		}
		/* string exists already */
		if ((rval=malloc(strlen(string)+1))) {
			*chppt=rval;
			strcpy(rval,string);
			return (LString) rval;
		}
	}
	fprintf(stderr,"Cexp: Line String Table exhausted\n");
	return 0;
}

#define ch (*pa->chpt)
#define getch() do { (pa->chpt)++;} while(0)

/* helper to save typing */
static int
prerr(void)
{
	yyerror("yylex: buffer overflow");
	return LEXERR;
}

static int
scanfrac(char *buf, char *chpt, int size, YYSTYPE *rval, CexpParserCtx pa)
{
int hasE=0;
	/* first, we put ch to the buffer */
	*(chpt++)=(char)ch; size--; /* assume it's still safe */
	getch();
	if (!isdigit(ch))
		return '.'; /* lonely '.' without attached number is perhaps a field separator */
	do {
		while(isdigit(ch) && size) {
			*(chpt++)=(char)ch; if (!--size) return prerr();
			getch();
		}
		if (toupper(ch)=='E' && !hasE) {
			*(chpt++)=(char)'E'; if (!--size) return prerr();
			getch();
			if ('-'==ch || '+'==ch) {
				*(chpt++)=(char)ch; if (!--size) return prerr();
				getch();
			}
			hasE=1;
		} else {
	break; /* the loop */
		}
	} while (1);
	*chpt=0;
	rval->val.type=TDouble;
	rval->val.tv.d=strtod(buf,&chpt);
	return *chpt ? LEXERR : NUMBER;
}

int
yylex(YYSTYPE *rval, void *arg)
{
unsigned long	num;
CexpParserCtx 	pa=arg;
char sbuf[80], limit=sizeof(sbuf)-1;
char *chpt;

	while (' '==ch || '\t'==ch)
		getch();

	if (isdigit(ch) || '\''==ch) {
		/* a number */
		num=0;

		if ('\''==ch) {
			/* char constant */
			getch();
			num=ch;
			if ('\\'==ch) {
				getch();
				/* escape sequence */
				switch (ch) {
					case 't': num='\t'; break;
					case 'n': num='\n'; break;
					case 'r': num='\r'; break;
					case '0': num=0;	break;
					case 'f': num='\f';	break;
					case '\\': num='\\';break;
					case '\'': num='\'';break;
					default:
						yyerror("Warning: unknown escape sequence, using unescaped char");
						num=ch;
					break;
				}
			}
			getch();
			if ('\''!=ch)
				yyerror("Warning: missing closing '");
			else
				getch();
			rval->val.tv.c=(unsigned char)num;
			rval->val.type=TUChar;
			return NUMBER;
		}
		chpt=sbuf;
		if ('0'==ch) {
			
			/* hex, octal or fractional */
			*(chpt++)=(char)ch; limit--;
			getch();
			if ('x'==ch) {
				/* a hex number */
				getch();
				while (isxdigit(ch)) {
					num<<=4;
					if (ch>='a')		num+=ch-'a'+10;
					else if (ch>='A')	num+=ch-'A'+10;
					else				num+=ch-'0';
					getch();
				}
			} else if ('.'==ch) {
				/* a decimal number */
				return scanfrac(sbuf,chpt,limit,rval,pa);
			} else {
				/* OK, it's octal */
				while ('0'<=ch && ch<'8') {
					num<<=3;
					num+=ch-'0';
					getch();
				}
			}
		} else {
			/* so it must be base 10 */
			do {
				*(chpt++)=(char)ch; limit--;
				num=10*num+(ch-'0');
				getch();
			} while (isdigit(ch) && limit);
			if (!limit) {
				return prerr();
			}
			if ('.'==ch) {
				/* it's a fractional number */
				return scanfrac(sbuf,chpt,limit,rval,pa);
			}
		}
		rval->val.tv.l=num;
		rval->val.type=TULong;
		return NUMBER;
	} else if ('.'==ch) {
		/* perhaps also a fractional number */
		return
			scanfrac(sbuf,sbuf,limit,rval,pa);
	} else if (isalpha(ch) || ISIDENTCHAR(ch)) {
		/* slurp in an identifier */
		chpt=sbuf;
		do {
			*(chpt++)=ch;
			getch();
		} while ((isalnum(ch)||ISIDENTCHAR(ch)) && (--limit > 0));
		*chpt=0;
		if (!limit)
			return prerr();
		/* is it one of the type cast keywords? */
		if (!strcmp(sbuf,"char"))
			return KW_CHAR;
		else if (!strcmp(sbuf,"short"))
			return KW_SHORT;
		else if (!strcmp(sbuf,"long"))
			return KW_LONG;
		else if (!strcmp(sbuf,"double"))
			return KW_DOUBLE;
		else if ((rval->sym=cexpSymLookup(sbuf, 0)))
			return CEXP_TYPE_FUNQ(rval->sym->value.type) ? FUNC : VAR;
		else if ((rval->sym=cexpVarLookup(sbuf,0))) {
			return UVAR;
		}

		/* it's a currently undefined symbol */
		return (rval->lstr=lstAddString(pa,sbuf)) ? IDENT : LEXERR;
	} else if ('"'==ch) {
		/* generate a string constant */
		char *dst;
		const char *strStart;
		dst=sbuf-1;
		strStart = pa->chpt+1;
		do {
		skipit:	
			dst++; limit--;
			getch();
			*dst=ch;
			if ('\\'==ch) {
				getch();
				switch (ch) {
					case 'n':	*dst='\n'; goto skipit;
					case 'r':	*dst='\r'; goto skipit;
					case 't':	*dst='\t'; goto skipit;
					case '"':	*dst='"';  goto skipit;
					case '\\':	           goto skipit;
					case '0':	*dst=0;    goto skipit;
					default:
						dst++; limit--; *dst=ch;
						break;
				}
			}
			if ('"'==ch) {
				*dst=0;
				getch();
				rval->val.type=TUCharP;
#ifdef CONFIG_STRINGS_LIVE_FOREVER
				rval->val.tv.p=cexpStrLookup(sbuf,1);
#else
				rval->val.tv.p=lstAddString(pa,sbuf);
#endif
				return rval->val.tv.p ? STR_CONST : LEXERR;
			}
		} while (ch && limit>2);
		return LEXERR_INCOMPLETE_STRING - (pa->chpt - strStart);
	} else {
		long rv=ch;
		if (rv) getch();

		/* comments? skip the rest of the line */
		if ('#'==rv || ('/'==ch && '/'==rv)) {
			while (ch && '\n'!=rv) {
				rv=ch;
				getch();
			}
			return '\n';
		}

		/* it's any kind of 'special' character such as
		 * an operator etc.
		 */

		/* check for 'double' character operators '&&' '||' '<<' '>>' '==' '!=' '<=' '>=' */
		switch (ch) { /* the second character */
			default: break;

			case '+': if ('+'==rv) rv=PP;  break;
			case '-': if ('-'==rv) rv=MM;  break;

			case '&': if ('&'==rv) rv=AND; break;
			case '|': if ('|'==rv) rv=OR;  break;

			case '<': if ('<'==rv) rv=SHL; break;
			case '>': if ('>'==rv) rv=SHR; break;


			case '=':
				switch (rv) {
					default: break;
					case '=': rv=EQ;	break;
					case '!': rv=NE;	break;
					case '<': rv=LE;	break;
					case '>': rv=GE;	break;
					case '+': rv=MODOP; rval->binop=OAdd;	break;
					case '-': rv=MODOP; rval->binop=OSub;	break;
					case '*': rv=MODOP; rval->binop=OMul;	break;
					case '/': rv=MODOP; rval->binop=ODiv;	break;
					case '%': rv=MODOP; rval->binop=OMod;	break;
					case '&': rv=MODOP; rval->binop=OAnd;	break;
					case '^': rv=MODOP; rval->binop=OXor;	break;
					case '|': rv=MODOP; rval->binop=OOr;	break;
				}
			break;
		}
		if (rv>255) getch(); /* skip second char */
		/* yyparse cannot deal with '\0' chars, so we translate it back to '\n'...*/
		if ((SHL==rv || SHR==rv) && '=' == ch) {
			getch();
			rval->binop = (SHL==rv ? OShL : OShR);
			rv=MODOP;
		}
		return rv ? rv : '\n';
	}
	return 0; /* seems to mean ERROR/EOF */
}

/* re-initialize a parser context to parse 'buf';
 * If called with a NULL argument, a new
 * context is created and initialized.
 *
 * RETURNS: initialized context
 */

static void
releaseStrings(CexpParserCtx ctx)
{
int			i;
char		**chppt;

	/* release the line string table */
	for (i=0,chppt=ctx->lineStrTbl;
		 i<sizeof(ctx->lineStrTbl)/sizeof(ctx->lineStrTbl[0]);
		 i++,chppt++) {
		if (*chppt) {
			free(*chppt);
			*chppt=0;
		}
	}
}

CexpParserCtx
cexpCreateParserCtx(FILE *f)
{
CexpParserCtx	ctx=0;

	assert(ctx=(CexpParserCtx)malloc(sizeof(*ctx)));
	memset(ctx,0,sizeof(*ctx));
	ctx->f = f;
	return ctx;
}

void
cexpResetParserCtx(CexpParserCtx ctx, const char *buf)
{
	ctx->chpt=buf;
	ctx->evalInhibit=0;
	releaseStrings(ctx);
}

void
cexpFreeParserCtx(CexpParserCtx ctx)
{
	releaseStrings(ctx);
}

void
yyerror(char*msg)
{
/* unfortunately, even %pure_parser doesn't pass us the parser argument along.
 * hence, it is not possible for a reentrant parser to tell us where we
 * should print :-( however, our caller may try to redirect stderr...
 */
fprintf(stderr,"Cexp syntax error: %s\n",msg);
}
